<?php
/*  PHPlog output generator for Weblog
    Copyright (C) 2002 Mathijs de Bruin
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
	    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function gen_error($error) {
	trigger_error ($error, FATAL); 
}

// This is the parent class for the weekly, monthly and daily stats generators
class GenStats {
	// Database connection
	var $conn;
	// Domain name for stats
	var $domain;
	
	// This is for the table-generation
	var $even;
	
	function table_start($header) {
		$even = 0;
		// FIXME: overhere CSS should be used
		echo "<table bordercolor=\"#999999\" border=\"1\" cellspacing=\"1\">\n";
		echo "\t<tr>\n";
		echo "\t\t<th>$header</th>\n";
		echo "\t\t<th>Hits</th>\n";
		echo "\t\t<th>Percent</th>\n";
		echo "\t</tr>\n";
	}
	
	function table_row($data, $cut=0, $url=0) {
		if ($this->$even) {
     		echo "\t<tr bgcolor=\"#EEEEEE\">\n";
			$this->$even--;
		} else {
			echo "\t<tr bgcolor=\"#FFFFFF\">\n";
			$this->$even++;
		}
		
  		for ($teller=0;$teller<3;$teller++) {
			if ($teller == 0) {
				if ($cut && strlen($data[0])>MAXLEN) {
					$col_value = substr($data[0],0,MAXLEN-3)."...";
				} else {
					$col_value =& $data[$teller];
				}
				if ($url)
					$col_value = "<a href=\"".$data[$teller]."\">".$col_value."</a>";
			} else {
				$col_value =& $data[$teller];
			}	
			echo "\t\t<td>$col_value</td>\n";
     	}  
     	echo "\t</tr>\n";
	}
	
	function table_end() {
		echo "</table>\n";
	}
	
	// SQL error handling
	function sql_error() {
		gen_error("MySQL query failed because ".mysql_error($this->conn));
	}

	// Initialize some values
	function GenStats($d, $c = NULL) {
		$this->domain= $d;
		$this->conn = $c;
	}
	
	// Connect to/select database
	function Init($database = DBNAME, $user = DBUSER, $pass = DBPASS, $host = DBHOST) {
		if (!isset($this->conn)) {
			$this->conn = mysql_pconnect($host, $user, $pass)
				or gen_error("Unable to connect to MySQL database");
		}
			
		mysql_select_db("weblog", $this->conn) or
			die('Fatal error, bailing out');
			//or gen_error('Failed selecting database');
	}
}
?>