<?php
/*  PHPlog output generator for Weblog
    Copyright (C) 2002 Mathijs de Bruin
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
	    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require('config.inc.php');
require('main.inc.php');

class PeriodStats extends GenStats {
	// Use this to store the requested date
	var $date;
	var $period;
	
	function SetPeriod($date, $period) {
		$this->date = $date;
		$this->period = $period - 1;
	}
	
	function Hosts($limit = MAXHOST) {
		$this->table_start('Host');
		
		// Corky workaround
		$date =&  $this->date;
		$domain =&  $this->domain;
		$period =& $this->period;
		
		$query = "SELECT @total:=SUM(stats.hits)
					FROM stats, vhost
					WHERE 	stats.data_type = 'host' AND
							stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
	    					stats.vhost_id = vhost.vhost_id AND
	    					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain';";
												
 		mysql_query($query, $this->conn) or
 			$this->sql_error();
	 
 				
		$query = "SELECT	IF(host.hostname IS NULL OR host.hostname=host.ip, INET_NTOA(host.ip), host.hostname) AS host,
                 			SUM(stats.hits) AS hits,
	             			ROUND((SUM(stats.hits)/@total)*100,2) AS percent
					FROM stats, host, vhost
            		WHERE	stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND 
                  			stats.data_type = 'host' AND 
		          			stats.data_id = host.host_id AND
	              			stats.vhost_id = vhost.vhost_id AND
	              			SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'
            		GROUP BY host
            		ORDER BY hits DESC, host
            		LIMIT $limit;";
		
 		$result = @mysql_query($query, $this->conn) or
 			$this->sql_error();
 
 		
		while ($line = mysql_fetch_array($result))
 			$this->table_row($line,1);

 		// Free result-set
 		mysql_free_result($result);
		$this->table_end();
	}
	
	function Referers($limit = MAXREFERER, $internal = 0) {
		$this->table_start('Referer');
		
		// Corky workaround
		$date =&  $this->date;
		$domain =&  $this->domain;
		$period =& $this->period;
		if ($internal) {
			$query1 = "SELECT @total:=SUM(stats.hits)
						FROM stats, vhost
						WHERE 	stats.data_type = 'referer' AND
								stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
								stats.vhost_id = vhost.vhost_id AND
	    						SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'";
			$query2 = "SELECT 	IF(referer.referer_string IS NULL OR referer.referer_string = '-', 'Unknown', referer.referer_string) AS referer,
								SUM(stats.hits) AS hits,
	   							ROUND((SUM(stats.hits)/@total)*100,2) AS percent
						FROM stats, referer, vhost
  						WHERE	stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND 
        						stats.data_type = 'referer' AND 
								stats.data_id = referer.referer_id AND
	    						stats.vhost_id = vhost.vhost_id AND
	    						SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'
  						GROUP BY referer
  						ORDER BY hits DESC, referer
  						LIMIT $limit;";
		} else {
			$query1 = "SELECT @total:=SUM(stats.hits)
						FROM stats, vhost, referer
						WHERE 	SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain' AND
								stats.vhost_id = vhost.vhost_id AND
								stats.data_type = 'referer' AND
								stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
								stats.data_id = referer.referer_id AND
								NOT INSTR(referer.referer_string, '$domain') AND
								referer.referer_string != '-';";

			$query2 = "SELECT 	referer.referer_string AS referer,
								SUM(stats.hits) AS hits,
	   							ROUND((SUM(stats.hits)/@total)*100,2) AS percent
						FROM stats, referer, vhost
  						WHERE	SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain' AND
								stats.vhost_id = vhost.vhost_id AND
								stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND 
        						stats.data_type = 'referer' AND 
								stats.data_id = referer.referer_id AND						
								NOT INSTR(referer.referer_string, '$domain') AND
								referer.referer_string != '-'
  						GROUP BY referer
  						ORDER BY hits DESC, referer
  						LIMIT $limit;";
		}										

	 	@mysql_query($query1, $this->conn) or
 			$this->sql_error();
	 	$result = @mysql_query($query2, $this->conn) or
 			$this->sql_error();
 		
		while ($line = mysql_fetch_array($result))
			$this->table_row($line,1,1);

 		// Free result-set
 		mysql_free_result($result);
		$this->table_end();
	}
	
	function OSes($limit = MAXOS) {
		$this->table_start('OS');
		
		// Corky workaround
		$date =&  $this->date;
		$domain =&  $this->domain;
		$period =& $this->period;
		
		$query = "SELECT @total:=SUM(stats.hits)
  					FROM stats, vhost
  					WHERE 	stats.data_type = 'agent' AND
	    					stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
	    					stats.vhost_id = vhost.vhost_id AND
	    					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain';";
												
 		mysql_query($query, $this->conn) or
 			$this->sql_error();
	 
 				
		$query = "SELECT 	IF(agent.os IS NULL OR agent.agent_string = '-' OR agent.agent_string = '', 'Unknown', agent.os) AS os,
       						SUM(stats.hits) AS hits,
	   						ROUND((SUM(stats.hits)/@total)*100,2) AS percent
  					FROM stats, agent, vhost
  					WHERE 	stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND 
        					stats.data_type = 'agent' AND 
							stats.data_id = agent.agent_id AND
	    					stats.vhost_id = vhost.vhost_id AND
	    					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'
  					GROUP BY os
  					ORDER BY hits DESC, os
  					LIMIT $limit;";
		
 		$result = @mysql_query($query, $this->conn) or
 			$this->sql_error();
 
 		
		while ($line = mysql_fetch_array($result))
			$this->table_row($line);

 		// Free result-set
 		mysql_free_result($result);
		$this->table_end();
	}
	
	function Browsers($limit = MAXBROWSER) {
		$this->table_start('Browser');
		
		// Corky workaround
		$date =&  $this->date;
		$domain =&  $this->domain;
		$period =& $this->period;
		
		$query = "SELECT @total:=SUM(stats.hits)
					FROM stats, vhost
					WHERE	stats.data_type = 'agent' AND
	    					stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
							stats.vhost_id = vhost.vhost_id AND
							SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain';";
												
 		mysql_query($query, $this->conn) or
 			$this->sql_error();
	 
 				
		$query = "SELECT 	IF(agent.browser IS NULL, IF(agent.agent_string = '-' OR agent.agent_string = '', 'Unknown', agent.agent_string), agent.browser) AS browser,
       						SUM(stats.hits) AS hits,
							ROUND((SUM(stats.hits)/@total)*100,2) AS percent
  					FROM stats, agent, vhost
  					WHERE	stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND 
        					stats.data_type = 'agent' AND 
							stats.data_id = agent.agent_id AND
	    					stats.vhost_id = vhost.vhost_id AND
	    					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'
  					GROUP BY browser
  					ORDER BY hits DESC, browser
  					LIMIT $limit;";
		
 		$result = @mysql_query($query, $this->conn) or
 			$this->sql_error();
 
 		
		while ($line = mysql_fetch_array($result))
 			$this->table_row($line,1);

 		// Free result-set
 		mysql_free_result($result);
		$this->table_end();
	}
	
	function URLs($limit = MAXURL) {
		$this->table_start('URL');
		
		// Corky workaround
		$date =&  $this->date;
		$domain =&  $this->domain;
		$period =& $this->period;
		
		$query = "SELECT @total:=SUM(stats.hits)
  					FROM stats, vhost
  					WHERE	stats.data_type = 'uri' AND
	    					stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
	    					stats.vhost_id = vhost.vhost_id AND
	    					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain';";
												
 		mysql_query($query, $this->conn) or
 			$this->sql_error();
	 
 				
		$query = "SELECT 	uri.uri_string as uri,
       						SUM(stats.hits) AS hits,
	   						ROUND((SUM(stats.hits)/@total)*100,2) AS percent
  					FROM stats, uri, vhost
  					WHERE	stats.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND 
        					stats.data_type = 'uri' AND 
							stats.data_id = uri.uri_id AND
	    					stats.vhost_id = vhost.vhost_id AND
	    					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'
  					GROUP BY uri
  					ORDER BY hits DESC, uri
  					LIMIT $limit;";
		
 		$result = @mysql_query($query, $this->conn) or
 			$this->sql_error();
 
 		
		while ($line = mysql_fetch_array($result))
 			$this->table_row($line,1);

 		// Free result-set
 		mysql_free_result($result);
		$this->table_end();
	}
	
	function HoursTotal() {
		// Corky workaround
		$date =&  $this->date;
		$domain =&  $this->domain;
		$period =& $this->period;
		
		$query = "SELECT	visits.hour AS Hour,
       						SUM(visits.hits) AS Hits,
       						SUM(visits.visits) AS Visits,
       						SUM(ROUND((visits.traffic/1048576),1)) AS Kbytes
  					FROM visits, vhost
  					WHERE	visits.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
        					visits.vhost_id = vhost.vhost_id AND
        					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'
  					GROUP BY Hour;";
					
		$result = @mysql_query($query) or
 			$this->sql_error();
			
		$max['Hits'] = 1;
		$max['Visits'] = 1;
		$max['KBytes'] = 1;
		
		while ($line = mysql_fetch_assoc($result)) {
 			$data['Hits'][$line['Hour']] = $line['Hits'];
			$data['Visits'][$line['Hour']] = $line['Visits'];
			$data['KBytes'][$line['Hour']] = $line['Kbytes'];
			
			if ($line['Hits'] > $max['Hits']) $max['Hits'] = $line['Hits'];
			if ($line['Visits'] > $max['Visits']) $max['Visits'] = $line['Visits'];
			if ($line['Kbytes'] > $max['KBytes']) $max['KBytes'] = $line['Kbytes'];
		}
		
 		// Resultaat-set vrij maken
 		mysql_free_result($result);

		echo "<table bordercolor=\"#999999\" border=\"1\" cellspacing=\"1\">\n";
		echo "\t<tr>\n";
		echo "\t\t<td></td>\n";
 		for ($teller=0;$teller<24;$teller++) {
 			echo "\t\t<td valign=\"bottom\">";
			if ($data['Hits'][$teller]) {
				echo "<img src=\"".PICSDIR."/hits.gif\" alt=\"".$data['Hits'][$teller]." hits ($teller-".($teller+1).")\" width=\"7\" height=\"".round(($data['Hits'][$teller]/$max['Hits'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/hits.gif\" alt=\"0 hits ($teller-".($teller+1).")\" width=\"7\" height=\"1\">";
			}
			if ($data['Visits'][$teller]) {
				echo "<img src=\"".PICSDIR."/visits.gif\" alt=\"".$data['Visits'][$teller]." visits ($teller-".($teller+1).")\"width=\"7\" height=\"".round(($data['Visits'][$teller]/$max['Visits'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/visits.gif\" alt=\"0 visits ($teller-".($teller+1).")\"width=\"7\" height=\"1\">";
			}
			if ($data['KBytes'][$teller]) {
				echo "<img src=\"".PICSDIR."/traffic.gif\" alt=\"".$data['KBytes'][$teller]." MB traffic ($teller-".($teller+1).")\"width=\"7\" height=\"".round(($data['KBytes'][$teller]/$max['KBytes'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/traffic.gif\" alt=\"0 MB traffic ($teller-".($teller+1).")\"width=\"7\" height=\"1\">";
			}
			echo "\t\t</td>\n";
		}
		
		echo "\t</tr>\n";
		echo "\t<tr>\n";
  		echo "\t\t<th width=\"70\">Hour</th>\n";
  		echo "\t\t<th>0</th>\n";
		echo "\t\t<th>1</th>\n";
		echo "\t\t<th>2</th>\n";
		echo "\t\t<th>3</th>\n";
		echo "\t\t<th>4</th>\n";
		echo "\t\t<th>5</th>\n";
		echo "\t\t<th>6</th>\n";
		echo "\t\t<th>7</th>\n";
		echo "\t\t<th>8</th>\n";
		echo "\t\t<th>9</th>\n";
		echo "\t\t<th>10</th>\n";
		echo "\t\t<th>11</th>\n";
		echo "\t\t<th>12</th>\n";
		echo "\t\t<th>13</th>\n";
		echo "\t\t<th>14</th>\n";
		echo "\t\t<th>15</th>\n";
		echo "\t\t<th>16</th>\n";
		echo "\t\t<th>17</th>\n";
		echo "\t\t<th>18</th>\n";
		echo "\t\t<th>19</th>\n";
		echo "\t\t<th>20</th>\n";
		echo "\t\t<th>21</th>\n";
		echo "\t\t<th>22</th>\n";
		echo "\t\t<th>23</th>\n";
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Hits</th>\n";

 		for ($teller=0;$teller<24;$teller++) {
			if ($data['Hits'][$teller]) {
				echo "\t\t<td bgcolor=\"#EFEDBB\" class=\"hitstable\">".$data['Hits'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#EFEDBB\" class=\"hitstable\">0</td>\n";
			}
		}
		
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Visits</th>\n";

 		for ($teller=0;$teller<24;$teller++) {
			if ($data['Visits'][$teller]) {
				echo "\t\t<td bgcolor=\"#A9CAA2\" class=\"hitstable\">".$data['Visits'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#A9CAA2\" class=\"hitstable\">0</td>\n";
			}
 		}
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Traffic</th>\n";
		for ($teller=0;$teller<24;$teller++) {
			if ($data['KBytes'][$teller]) {
				echo "\t\t<td bgcolor=\"#F0BA81\" class=\"hitstable\">".$data['KBytes'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#F0BA81\" class=\"hitstable\">0</td>\n";
			}
 		}
		echo "\t</tr>\n";
		echo "</table>";
	}
	
	function HoursAverage() {
		// Corky workaround
		$date =&  $this->date;
		$domain =&  $this->domain;
		$period =& $this->period;
		
		$query = "SELECT	visits.hour AS Hour,
       						ROUND(AVG(visits.hits)) AS Hits,
       						ROUND(AVG(visits.visits)) AS Visits,
       						ROUND(AVG((visits.traffic/1048576)),1) AS Kbytes
  					FROM visits, vhost
  					WHERE	visits.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
        					visits.vhost_id = vhost.vhost_id AND
        					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'
  					GROUP BY Hour;";
					
		$result = @mysql_query($query) or
 			$this->sql_error();
			
		$max['Hits'] = 1;
		$max['Visits'] = 1;
		$max['KBytes'] = 1;
		
		while ($line = mysql_fetch_assoc($result)) {
 			$data['Hits'][$line['Hour']] = $line['Hits'];
			$data['Visits'][$line['Hour']] = $line['Visits'];
			$data['KBytes'][$line['Hour']] = $line['Kbytes'];
			
			if ($line['Hits'] > $max['Hits']) $max['Hits'] = $line['Hits'];
			if ($line['Visits'] > $max['Visits']) $max['Visits'] = $line['Visits'];
			if ($line['Kbytes'] > $max['KBytes']) $max['KBytes'] = $line['Kbytes'];
		}
		
 		// Resultaat-set vrij maken
 		mysql_free_result($result);

		echo "<table bordercolor=\"#999999\" border=\"1\" cellspacing=\"1\">\n";
		echo "\t<tr>\n";
		echo "\t\t<td></td>\n";
 		for ($teller=0;$teller<24;$teller++) {
 			echo "\t\t<td valign=\"bottom\">";
			if ($data['Hits'][$teller]) {
				echo "<img src=\"".PICSDIR."/hits.gif\" alt=\"".$data['Hits'][$teller]." hits ($teller-".($teller+1).")\" width=\"7\" height=\"".round(($data['Hits'][$teller]/$max['Hits'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/hits.gif\" alt=\"0 hits ($teller-".($teller+1).")\" width=\"7\" height=\"1\">";
			}
			if ($data['Visits'][$teller]) {
				echo "<img src=\"".PICSDIR."/visits.gif\" alt=\"".$data['Visits'][$teller]." visits ($teller-".($teller+1).")\"width=\"7\" height=\"".round(($data['Visits'][$teller]/$max['Visits'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/visits.gif\" alt=\"0 visits ($teller-".($teller+1).")\"width=\"7\" height=\"1\">";
			}
			if ($data['KBytes'][$teller]) {
				echo "<img src=\"".PICSDIR."/traffic.gif\" alt=\"".$data['KBytes'][$teller]." MB traffic ($teller-".($teller+1).")\"width=\"7\" height=\"".round(($data['KBytes'][$teller]/$max['KBytes'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/traffic.gif\" alt=\"0 MB traffic ($teller-".($teller+1).")\"width=\"7\" height=\"1\">";
			}
			echo "\t\t</td>\n";
		}
		
		echo "\t</tr>\n";
		echo "\t<tr>\n";
  		echo "\t\t<th width=\"70\">Hour</th>\n";
  		echo "\t\t<th>0</th>\n";
		echo "\t\t<th>1</th>\n";
		echo "\t\t<th>2</th>\n";
		echo "\t\t<th>3</th>\n";
		echo "\t\t<th>4</th>\n";
		echo "\t\t<th>5</th>\n";
		echo "\t\t<th>6</th>\n";
		echo "\t\t<th>7</th>\n";
		echo "\t\t<th>8</th>\n";
		echo "\t\t<th>9</th>\n";
		echo "\t\t<th>10</th>\n";
		echo "\t\t<th>11</th>\n";
		echo "\t\t<th>12</th>\n";
		echo "\t\t<th>13</th>\n";
		echo "\t\t<th>14</th>\n";
		echo "\t\t<th>15</th>\n";
		echo "\t\t<th>16</th>\n";
		echo "\t\t<th>17</th>\n";
		echo "\t\t<th>18</th>\n";
		echo "\t\t<th>19</th>\n";
		echo "\t\t<th>20</th>\n";
		echo "\t\t<th>21</th>\n";
		echo "\t\t<th>22</th>\n";
		echo "\t\t<th>23</th>\n";
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Hits</th>\n";

 		for ($teller=0;$teller<24;$teller++) {
			if ($data['Hits'][$teller]) {
				echo "\t\t<td bgcolor=\"#EFEDBB\" class=\"hitstable\">".$data['Hits'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#EFEDBB\" class=\"hitstable\">0</td>\n";
			}
		}
		
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Visits</th>\n";

 		for ($teller=0;$teller<24;$teller++) {
			if ($data['Visits'][$teller]) {
				echo "\t\t<td bgcolor=\"#A9CAA2\" class=\"hitstable\">".$data['Visits'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#A9CAA2\" class=\"hitstable\">0</td>\n";
			}
 		}
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Traffic</th>\n";
		for ($teller=0;$teller<24;$teller++) {
			if ($data['KBytes'][$teller]) {
				echo "\t\t<td bgcolor=\"#F0BA81\" class=\"hitstable\">".$data['KBytes'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#F0BA81\" class=\"hitstable\">0</td>\n";
			}
 		}
		echo "\t</tr>\n";
		echo "</table>";
	}
	
	function WeeksTotal() {
		// Corky workaround
		$date =&  $this->date;
		$domain =&  $this->domain;
		$period =& $this->period;
		
		$query = "SELECT 	WEEKDAY(visits.date) AS Day,
							SUM(visits.hits) AS Hits,
							SUM(visits.visits) AS Visits,
							ROUND(SUM((visits.traffic/1048576)),1) AS Kbytes
  					FROM visits, vhost
  					WHERE	visits.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
        					visits.vhost_id = vhost.vhost_id AND
        					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'
  					GROUP BY Day;";
					
		$result = @mysql_query($query) or
 			$this->sql_error();
			
		$max['Hits'] = 1;
		$max['Visits'] = 1;
		$max['KBytes'] = 1;
		
		while ($line = mysql_fetch_assoc($result)) {
 			$data['Hits'][$line['Day']] = $line['Hits'];
			$data['Visits'][$line['Day']] = $line['Visits'];
			$data['KBytes'][$line['Day']] = $line['Kbytes'];
			
			if ($line['Hits'] > $max['Hits']) $max['Hits'] = $line['Hits'];
			if ($line['Visits'] > $max['Visits']) $max['Visits'] = $line['Visits'];
			if ($line['Kbytes'] > $max['KBytes']) $max['KBytes'] = $line['Kbytes'];
		}
		
 		// Resultaat-set vrij maken
 		mysql_free_result($result);

		echo "<table bordercolor=\"#999999\" border=\"1\" cellspacing=\"1\">\n";
		echo "\t<tr>\n";
		echo "\t\t<td></td>\n";
 		for ($teller=0;$teller<7;$teller++) {
 			echo "\t\t<td valign=\"bottom\">";
			if ($data['Hits'][$teller]) {
				echo "<img src=\"".PICSDIR."/hits.gif\" alt=\"".$data['Hits'][$teller]." hits ($teller-".($teller+1).")\" width=\"7\" height=\"".round(($data['Hits'][$teller]/$max['Hits'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/hits.gif\" alt=\"0 hits ($teller-".($teller+1).")\" width=\"7\" height=\"1\">";
			}
			if ($data['Visits'][$teller]) {
				echo "<img src=\"".PICSDIR."/visits.gif\" alt=\"".$data['Visits'][$teller]." visits ($teller-".($teller+1).")\"width=\"7\" height=\"".round(($data['Visits'][$teller]/$max['Visits'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/visits.gif\" alt=\"0 visits ($teller-".($teller+1).")\"width=\"7\" height=\"1\">";
			}
			if ($data['KBytes'][$teller]) {
				echo "<img src=\"".PICSDIR."/traffic.gif\" alt=\"".$data['KBytes'][$teller]." MB traffic ($teller-".($teller+1).")\"width=\"7\" height=\"".round(($data['KBytes'][$teller]/$max['KBytes'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/traffic.gif\" alt=\"0 MB traffic ($teller-".($teller+1).")\"width=\"7\" height=\"1\">";
			}
			echo "\t\t</td>\n";
		}
		
		echo "\t</tr>\n";
		echo "\t<tr>\n";
  		echo "\t\t<th width=\"70\">Hour</th>\n";
  		echo "\t\t<th>Mon</th>\n";
		echo "\t\t<th>Tue</th>\n";
		echo "\t\t<th>Wed</th>\n";
		echo "\t\t<th>Thu</th>\n";
		echo "\t\t<th>Fri</th>\n";
		echo "\t\t<th>Sat</th>\n";
		echo "\t\t<th>Sun</th>\n";

		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Hits</th>\n";

 		for ($teller=0;$teller<7;$teller++) {
			if ($data['Hits'][$teller]) {
				echo "\t\t<td bgcolor=\"#EFEDBB\" class=\"hitstable\">".$data['Hits'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#EFEDBB\" class=\"hitstable\">0</td>\n";
			}
		}
		
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Visits</th>\n";

 		for ($teller=0;$teller<7;$teller++) {
			if ($data['Visits'][$teller]) {
				echo "\t\t<td bgcolor=\"#A9CAA2\" class=\"hitstable\">".$data['Visits'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#A9CAA2\" class=\"hitstable\">0</td>\n";
			}
 		}
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Traffic</th>\n";
		for ($teller=0;$teller<7;$teller++) {
			if ($data['KBytes'][$teller]) {
				echo "\t\t<td bgcolor=\"#F0BA81\" class=\"hitstable\">".$data['KBytes'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#F0BA81\" class=\"hitstable\">0</td>\n";
			}
 		}
		echo "\t</tr>\n";
		echo "</table>";
	}
		function WeeksAverage() {
		// Corky workaround
		$date =&  $this->date;
		$domain =&  $this->domain;
		$period =& $this->period;
		
		$query = "SELECT 	WEEK(visits.date) AS Week,	
							WEEKDAY(visits.date) AS Day,
							SUM(visits.hits) AS Hits,
							SUM(visits.visits) AS Visits,
							SUM(visits.traffic/1048576) AS Kbytes
  					FROM visits, vhost
  					WHERE	visits.date BETWEEN '$date' AND '$date' + INTERVAL $period DAY AND
        					visits.vhost_id = vhost.vhost_id AND
        					SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = '$domain'
  					GROUP BY Day;";
					
		$result = @mysql_query($query) or
 			$this->sql_error();
		
		// Avoid divisins by zero
		$max['Hits'] = 1;
		$max['Visits'] = 1;
		$max['KBytes'] = 1;
		
		$weekcount = 0;
		
		while ($line = mysql_fetch_assoc($result)) {
			if (!isset($week[$line['Week']])) {
				$week[$line['Week']] = 1;
				$weekcount++;
			}
 			$data['Hits'][$line['Day']] += $line['Hits'];
			$data['Visits'][$line['Day']] += $line['Visits'];
			$data['KBytes'][$line['Day']] += $line['Kbytes'];
			
			if ($line['Hits'] > $max['Hits']) $max['Hits'] = $line['Hits'];
			if ($line['Visits'] > $max['Visits']) $max['Visits'] = $line['Visits'];
			if ($line['Kbytes'] > $max['KBytes']) $max['KBytes'] = $line['Kbytes'];
		}
		
		$data['Hits'][$line['Day']] /= $weekcount;
		$data['Visits'][$line['Day']] /= $weekcount;
		$data['KBytes'][$line['Day']] /= $weekcount;
		
 		// Resultaat-set vrij maken
 		mysql_free_result($result);

		echo "<table bordercolor=\"#999999\" border=\"1\" cellspacing=\"1\">\n";
		echo "\t<tr>\n";
		echo "\t\t<td></td>\n";
 		for ($teller=0;$teller<7;$teller++) {
 			echo "\t\t<td valign=\"bottom\">";
			if ($data['Hits'][$teller]) {
				echo "<img src=\"".PICSDIR."/hits.gif\" alt=\"".$data['Hits'][$teller]." hits ($teller-".($teller+1).")\" width=\"7\" height=\"".round(($data['Hits'][$teller]/$max['Hits'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/hits.gif\" alt=\"0 hits ($teller-".($teller+1).")\" width=\"7\" height=\"1\">";
			}
			if ($data['Visits'][$teller]) {
				echo "<img src=\"".PICSDIR."/visits.gif\" alt=\"".$data['Visits'][$teller]." visits ($teller-".($teller+1).")\"width=\"7\" height=\"".round(($data['Visits'][$teller]/$max['Visits'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/visits.gif\" alt=\"0 visits ($teller-".($teller+1).")\"width=\"7\" height=\"1\">";
			}
			if ($data['KBytes'][$teller]) {
				echo "<img src=\"".PICSDIR."/traffic.gif\" alt=\"".$data['KBytes'][$teller]." MB traffic ($teller-".($teller+1).")\"width=\"7\" height=\"".round(($data['KBytes'][$teller]/$max['KBytes'])*100)."\">";
			} else {
				echo "<img src=\"".PICSDIR."/traffic.gif\" alt=\"0 MB traffic ($teller-".($teller+1).")\"width=\"7\" height=\"1\">";
			}
			echo "\t\t</td>\n";
		}
		
		echo "\t</tr>\n";
		echo "\t<tr>\n";
  		echo "\t\t<th width=\"70\">Hour</th>\n";
  		echo "\t\t<th>Mon</th>\n";
		echo "\t\t<th>Tue</th>\n";
		echo "\t\t<th>Wed</th>\n";
		echo "\t\t<th>Thu</th>\n";
		echo "\t\t<th>Fri</th>\n";
		echo "\t\t<th>Sat</th>\n";
		echo "\t\t<th>Sun</th>\n";

		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Hits</th>\n";

 		for ($teller=0;$teller<7;$teller++) {
			if ($data['Hits'][$teller]) {
				echo "\t\t<td bgcolor=\"#EFEDBB\" class=\"hitstable\">".$data['Hits'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#EFEDBB\" class=\"hitstable\">0</td>\n";
			}
		}
		
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Visits</th>\n";

 		for ($teller=0;$teller<7;$teller++) {
			if ($data['Visits'][$teller]) {
				echo "\t\t<td bgcolor=\"#A9CAA2\" class=\"hitstable\">".$data['Visits'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#A9CAA2\" class=\"hitstable\">0</td>\n";
			}
 		}
		echo "\t</tr>\n";
		echo "\t<tr>\n";
		echo "\t\t<th>Traffic</th>\n";
		for ($teller=0;$teller<7;$teller++) {
			if ($data['KBytes'][$teller]) {
				echo "\t\t<td bgcolor=\"#F0BA81\" class=\"hitstable\">".$data['KBytes'][$teller]."</td>\n";
			} else {
				echo "\t\t<td bgcolor=\"#F0BA81\" class=\"hitstable\">0</td>\n";
			}
 		}
		echo "\t</tr>\n";
		echo "</table>";
	}
}
?>
