SELECT @total:=SUM(stats.hits)
  FROM stats, vhost
  WHERE stats.data_type = 'agent' AND
	stats.date BETWEEN '2002-02-02' AND '2002-02-05' AND
	stats.vhost_id = vhost.vhost_id AND
	SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = 'dokterbob.net';
			      
SELECT IF(agent.browser IS NULL, IF(agent.agent_string = '-' OR agent.agent_string = '', 'Unknown', agent.agent_string), agent.browser) AS Browser,
       ROUND((SUM(stats.hits)/@total)*100,2) AS Percent,
       SUM(stats.hits) AS Hits
  FROM stats, agent, vhost
  WHERE stats.data_type = 'agent' AND
	stats.data_id = agent.agent_id AND
	stats.vhost_id = vhost.vhost_id AND
	SUBSTRING_INDEX(vhost.vhost_string, '.', -2) = 'doterbob.net'
  GROUP BY Browser
  ORDER BY Hits DESC,
           Browser;